
#include <stdafx.h>

#include <stdio.h>

#include "resource.h"


#include "os.h"
#include "wimp.h"
#include "font.h"
#include "bbc.h"


#include "wos.h"
#include "poll.h"
#include "temp.h"
#include "pane.h"
#include "etc.h"
#include "redraw.h"
#include "colour.h"
#include "bf.h"
#include "comdialogs.h"
#include "comctls.h"
#include "deb.h"
#include "osunits.h"


#include "reslink.h"
#include "mainwin.h"
#include "soln.h"
#include "grid.h"
#include "memblock.h"
#include "dc.h"
#include "edit.h"
#include "file.h"

#include "customgrid.h"






static int customhandle;

static int xtextcolour;
static int xgridcolour;
static int xfillcolour;
static int xemptycolour;

static font_description xtextfont;
static font_description xcluefont;

static int xdmask;
static int xdrawsolutions;



static os_error * customicon(int handle,int userhandle,wimp_mousestr * m);




static os_error * redrawsample(wimp_redrawstr * r,int handle,int icon,font_description * fd,int rgbpal,int backcol)
{
 os_error  * err;
 int         fh;
 int         bx;
 int         by;
 iconstr     ic;
 font_metric metric;
 int         shift;

 err=font_find_description(fd,&fh);
 if(!err)
 {
           err=font_setcolour(fh,PALTRANSPARENT,rgbpal,0);
  if(!err) err=font_align(FA_LEFT|FA_BASELINE);
  if(!err) err=font_getmetric(&metric);

  if(!err) err=geti(handle,icon,&ic);
  if(!err)
  {
   bx=r->box.x0-r->scx;
   by=r->box.y1-r->scy;

            err=setgcol(backcol);
   if(!err) err=bbc_rectanglefill(bx+ic.ix0,by+ic.iy1,ic.ix1-ic.ix0,ic.iy0-ic.iy1);
   if(!err) err=bbc_gwindow(bx+ic.ix0,by+ic.iy0,bx+ic.ix1,by+ic.iy1);
   if(!err)
   {
    shift=ic.iy1-ypix2os(metric.ascent)-((ic.iy1-ic.iy0)-ypix2os(metric.height))/2;
    err=font_paint("ABCabc123",font_ABS|font_OSCOORDS|font_BACKBLEND,bx+ic.ix0,by+shift);
    bbc_gwindowrelease();
   }
  }
  font_lose(fh);
 }

 return(err);
}





static os_error * customredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,IDC_CUSTOM_GRID,xgridcolour);
  redrawsample(redrawstr,handle,IDC_CUSTOM_GRIDFONT,&xtextfont,xtextcolour,xemptycolour);
  redrawblock(redrawstr,handle,IDC_CUSTOM_EMPTY,xemptycolour);
  redrawblock(redrawstr,handle,IDC_CUSTOM_TEXT,xtextcolour);

  if(gridtype==CROSSTYPE)
  {
   redrawblock(redrawstr,handle,IDC_CUSTOM_FILL,xfillcolour);
   redrawsample(redrawstr,handle,IDC_CUSTOM_NUMBERFONT,&xcluefont,xtextcolour,xemptycolour);
  }

  err=wimp_get_rectangle(redrawstr,&more);
 }
 return(err);
}



static os_error * customredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=customredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}




static os_error * customclose(int w,int ok)
{
 os_error * err;
 char     * p;
 int        ratio;
 int        minlen;

 ratio=gridmeshratio;
 minlen=minsollen;

 err=iconaddr(customhandle,IDC_CUSTOM_MESH,&p);
 sscanf(p,"%d",&ratio);
 if(ratio<150) ratio=150;
 if(ratio>400) ratio=400;

 if(gridtype==SQUARETYPE)
 {
  err=iconaddr(customhandle,IDC_CUSTOM_MINWORDLEN,&p);
  sscanf(p,"%d",&minlen);
  if(minlen<1) minlen=1;
  if(minlen>12) minlen=12;
 }

 if(!err)
 {
  enablewindow(mainhandle,1,0);
  
  remclickevent(customicon,customhandle,0);
  remcloseevent(customclose,customhandle,0);
  remredrawevent(customredraw,customhandle,0);

  err=closedown(&customhandle);
  if(!err)
  {
   if(ok)
   {
    textcolour=xtextcolour;
    gridcolour=xgridcolour;
    fillcolour=xfillcolour;
    emptycolour=xemptycolour;
    textfont=xtextfont;
    cluefont=xcluefont;
    gridmeshratio=ratio;
    minsollen=minlen;
    dmask=xdmask;
    drawsolutions=xdrawsolutions;
    setparameters();
    setgridextent();
    refreshgrid();
    modfile();
   }
  }
 }


 return(err);

 USE(w);
}







static os_error * customicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        result;


 err=NULL;

 switch(m->i)
 {

  case   IDC_CUSTOM_GRID:
   case IDC_CUSTOM_GRIDR:
                         err=cd_getcolour(handle,0,&xgridcolour,&result);
                         if(result) repainticon(handle,IDC_CUSTOM_GRID);
                         break;

  case  IDC_CUSTOM_FILL:
  case IDC_CUSTOM_FILLR:
                         err=cd_getcolour(handle,0,&xfillcolour,&result);
                         if(result) repainticon(handle,IDC_CUSTOM_FILL);
                         break;

  case IDC_CUSTOM_EMPTY:
 case IDC_CUSTOM_EMPTYR:
                         err=cd_getcolour(handle,0,&xemptycolour,&result);
                         if(result)
                         {
                          repainticon(handle,IDC_CUSTOM_EMPTY);
                          repainticon(handle,IDC_CUSTOM_GRIDFONT);
                          repainticon(handle,IDC_CUSTOM_NUMBERFONT);
                         }
                         break;

  case  IDC_CUSTOM_TEXT:
  case IDC_CUSTOM_TEXTR:
                         err=cd_getcolour(handle,0,&xtextcolour,&result);
                         if(result) repainticon(handle,IDC_CUSTOM_TEXT);
                         break;

 case  IDC_CUSTOM_GRIDFONT:
 case IDC_CUSTOM_GRIDFONTR:
                         err=cd_getfont(handle,0,&xtextfont,&result);
                         if(result) repainticon(handle,IDC_CUSTOM_GRIDFONT);
                         break;

 case  IDC_CUSTOM_NUMBERFONT:
 case IDC_CUSTOM_NUMBERFONTR:
                         err=cd_getfont(handle,0,&xcluefont,&result);
                         if(result) repainticon(handle,IDC_CUSTOM_NUMBERFONT);
                         break;
                         
               case IDOK:
                         err=customclose(handle,1);
                         break;

           case IDCANCEL:
                         err=customclose(handle,0);
                         break;


    case IDC_CUSTOM_SHOW:
                         xdrawsolutions^=1;
                         break;


    case   IDC_CUSTOM_UP:
                         xdmask^=0x10;
                         break;

  case   IDC_CUSTOM_DOWN:
                         xdmask^=0x8;
                         break;

    case IDC_CUSTOM_LEFT:
                         xdmask^=0x1;
                         break;

   case IDC_CUSTOM_RIGHT:
                         xdmask^=0x20;
                         break;


    case   IDC_CUSTOM_UPLEFT:
                         xdmask^=0x4;
                         break;

  case   IDC_CUSTOM_DOWNLEFT:
                         xdmask^=0x2;
                         break;

    case   IDC_CUSTOM_UPRIGHT:
                         xdmask^=0x80;
                         break;

  case   IDC_CUSTOM_DOWNRIGHT:
                         xdmask^=0x40;
                         break;

 }

 return(err);

 USE(userhandle);
}






os_error * customgrid(int parent)
{
 os_error * err;

 if(customhandle) err=forward(customhandle,0,NULL);
 else
 {
  err=createwindowparent(gridtype==CROSSTYPE?TCUSTOM:TCUSTOMW,&customhandle,parent);

  if(!err)
  {
   xtextcolour=textcolour;
   xgridcolour=gridcolour;
   xfillcolour=fillcolour;
   xemptycolour=emptycolour;
   xtextfont=textfont;
   xcluefont=cluefont;
   xdmask=dmask;
   xdrawsolutions=drawsolutions;

   addclickevent(customicon,customhandle,0);
   addcloseevent(customclose,customhandle,0);
   addredrawevent(customredraw,customhandle,0);

   cc_spinrange(customhandle,IDC_CUSTOM_MESHSPIN,90,400);
   writeiconf(customhandle,IDC_CUSTOM_MESH,"%d",gridmeshratio);

   if(gridtype==SQUARETYPE)
   {
    cc_spinrange(customhandle,IDC_CUSTOM_MINWORDLENSPIN,1,12);
    writeiconf(customhandle,IDC_CUSTOM_MINWORDLEN,"%d",minsollen);

    selectst(customhandle,IDC_CUSTOM_SHOW,xdrawsolutions);
    selectst(customhandle,IDC_CUSTOM_UP,xdmask & 0x10);
    selectst(customhandle,IDC_CUSTOM_DOWN,xdmask & 0x8);
    selectst(customhandle,IDC_CUSTOM_LEFT,xdmask & 0x1);
    selectst(customhandle,IDC_CUSTOM_RIGHT,xdmask & 0x20);
    selectst(customhandle,IDC_CUSTOM_UPLEFT,xdmask & 0x4);
    selectst(customhandle,IDC_CUSTOM_DOWNLEFT,xdmask & 0x2);
    selectst(customhandle,IDC_CUSTOM_UPRIGHT,xdmask & 0x80);
    selectst(customhandle,IDC_CUSTOM_DOWNRIGHT,xdmask & 0x40);
   }


   popup(customhandle,0);
   iecarrot(customhandle,IDC_CUSTOM_MESH);

   enablewindow(mainhandle,0,0);
  }
 }

 return(err);
}



/************************************************************************************/

static int gridsizehandle;

static os_error * gridsizeicon(int handle,int userhandle,wimp_mousestr * m);


static os_error * gridsizeclose(int w,int ok)
{
 os_error * err=NULL;
 int        xsize;
 int        ysize;
 char     * p;

 iconaddr(gridsizehandle,IDC_GRID_WIDTH,&p);
 sscanf(p,"%d",&xsize);
 iconaddr(gridsizehandle,IDC_GRID_HEIGHT,&p);
 sscanf(p,"%d",&ysize);

 if(xsize<2)     xsize=maxx;
 if(xsize>=MAXX) xsize=maxx;
 if(ysize<2)     ysize=maxy;
 if(ysize>=MAXY) ysize=maxy;


 if(!err)
 {
  enablewindow(mainhandle,1,0);
  
  remclickevent(gridsizeicon,gridsizehandle,0);
  remcloseevent(gridsizeclose,gridsizehandle,0);

  err=closedown(&gridsizehandle);
  if(!err)
  {
   if(ok)
   {


    setsize(xsize,ysize);
   }
  }
 }

 return(err);

 USE(w);
}



static os_error * gridsizeicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
                         
               case IDOK:
                         err=gridsizeclose(handle,1);
                         break;

           case IDCANCEL:
                         err=gridsizeclose(handle,0);
                         break;

 }

 return(err);

 USE(userhandle);
}






os_error * gridsize(int parent)
{
 os_error * err;

 if(gridsizehandle) err=forward(gridsizehandle,0,NULL);
 else
 {
  err=createwindowparent(TGRIDSIZE,&gridsizehandle,parent);

  if(!err)
  {
   addclickevent(gridsizeicon,gridsizehandle,0);
   addcloseevent(gridsizeclose,gridsizehandle,0);

   cc_spinrange(gridsizehandle,IDC_GRID_SPIN_WIDTH,2,MAXX);
   writeiconf(gridsizehandle,IDC_GRID_WIDTH,"%d",maxx);
   cc_spinrange(gridsizehandle,IDC_GRID_SPIN_HEIGHT,2,MAXY);
   writeiconf(gridsizehandle,IDC_GRID_HEIGHT,"%d",maxy);

   popup(gridsizehandle,0);

   iecarrot(gridsizehandle,IDC_GRID_WIDTH);

   enablewindow(mainhandle,0,0);
  }
 }

 return(err);
}



