// edit.cpp
//

#include "stdafx.h"
#include "afxres.h"
#include "commdlg.h"
#include "commctrl.h"
#include "resource.h"
#include "shellapi.h"

#include <string.h>
#include <stdio.h>
#include <time.h>

#include "etc.h"


#include "os.h"
#include "wimp.h"
#include "bbc.h"
#include "font.h"
#include "werr.h"


#include "key.h"
#include "bf.h"
#include "hourglass.h"
#include "wos.h"
#include "poll.h"
#include "pane.h"
#include "temp.h"
#include "mlo.h"
#include "colour.h"
#include "load.h"
#include "save.h"
#include "conf.h"
#include "comctls.h"
#include "trans.h"
#include "osunits.h"


#include "deb.h"


#include "main.h"
#include "mainwin.h"
#include "constants.h"
#include "soln.h"
#include "grid.h"
#include "reslink.h"
#include "memblock.h"
#include "dc.h"
#include "spell.h"

#include "edit.h"



#define WDMARGIN  0
#define WDXMARGIN 4
#define WDSHIFT   2




char   guessit[STRLEN];
char   checkstring[STRLEN];

int    checkmode=0;     /* what mode is the edit window in */



dict guessdc={0,0,NULL,NULL};  /* dictionary to put guesses in     */
dict scrapdc={0,0,NULL,NULL};  /* dictionary to put trash   in     */


int guessmode=1;   /* if we are in guess mode          */
int curdict;       /* current dictionary in file map   */



static dict * checkd;
static int    checkno;
static int    checkselec;
static int    checkfocusn;
static int    checkhandle;
static int    checkpanehandle;
static char * checktitle;





static os_error * checkicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * checkkey(int handle,int userhandle,int icon,int * key);
static os_error * checkpaneicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * checkpanekey(int handle,int userhandle,int icon,int * key);
static os_error * checkpaneredraw(int handle,int userhandle);
static os_error * checkpanecaret(int handle,int userhandle,int gain);
static void godictmode(int full);



static void stripstring(char * dest,char * src)
{
 int c;

 do
 {
  c=*src++;



  *dest++=(char)c;
 } while(c);
}





static comboboxh comboboxhandle;


static os_error * checkcomboboxeventfn(int event,int handle,int userhandle,int data,void * datap)
{
 os_error * err;

 err=NULL;

 if(event==CC_COMBOBOXSELECT)
 {
  curdict=data;
  godictmode(!guessmode);
 }

 return(err);

 USE(datap);
 USE(userhandle);
 USE(handle);
}




static os_error * checkcomboinit(int handle)
{
 os_error * err;
 int        i;

 err=cc_addcombobox(handle,0,IDC_CHECK_COMBO,&comboboxhandle,checkcomboboxeventfn);

 if(!err)
 {
  for(i=0;i<nodc;i++)
  {
   cc_addcomboboxstring(comboboxhandle,dtable[dcmap[i]].name);
  }

  cc_selectcombobox(comboboxhandle,0);
 }

 return(err);
}




static os_error * checkcombofinit(void)
{

 return(cc_remcombobox(comboboxhandle));
} 





static void checkopenwordsn(int n)
{
 int       y;
 windowstr window;

 getw(checkpanehandle,&window);

 y=-(n+1)*(WDMARGIN+editheight)+((window.y1-window.y0)/2);

 openatscroll(checkpanehandle,0,y);
}





static os_error * checkrefreshwords(int n)
{
 os_error       * err;
 wimp_redrawstr   r;
 windowstr        window;

 err=getw(checkpanehandle,&window);
 r.box.x0=0;
 r.box.x1=window.x1-window.x0;

 if(n<0)
 {
  r.box.y1=window.scy;
  r.box.y0=r.box.y1-(window.y1-window.y0);
 }
 else
 {
  r.box.y1=-n*(editheight+WDMARGIN)-WDMARGIN-WDSHIFT+2*cvdu.extray;
  r.box.y0=r.box.y1-editheight-WDMARGIN-4*cvdu.extray;
 }

 r.w=checkpanehandle;
 wimp_force_redraw(&r);

 return(err);
}




static void checkpaneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*editheight+WDMARGIN);
 bot=-((n+1)*editheight+WDMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

 wimp_open_wind(&wblock.o);
}






static void checkdemon(void)
{
 os_error * err;
 int        found;
 int        n;
 int        ntemp;
 int        flags=0;
 word       words;
 char       buff[64];
 char     * p;


 err=iconaddr(checkhandle,IDC_CHECK_TEXT,&p);
 if(!err)
 {
  stripstring(buff,p);

  found=findword(buff,checkd,&words,&flags);
  if(flags & 0x1) found=0;
  n=words.wordn;

  if(!found || n!=checkselec)
  {
   checkpaneopenline(checkpanehandle,n);
   if(checkselec>=0)
   {
    ntemp=checkselec;
    checkselec=-1;
    checkrefreshwords(ntemp);
   }

   if(found)
   {
    checkselec=n;
    checkrefreshwords(checkselec);
   }
  }
 }
}


static os_error * checkupdate(int handle,int icon,int userhandle)
{
 checkdemon();
 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}




static os_error * setcext(void)
{
 os_error * err;
 int        miny;

 miny=nowords(checkd)*(editheight+WDMARGIN)+WDMARGIN;  

 err=extent(checkpanehandle,0,-miny,editwidth,0);

 return(err);
}




static os_error * setcheckextent(void)
{
 os_error * err;
 
          err=setcext();
// if(!err) err=writeiconf(checkhandle,IDC_CHECK_WORDS,"%d",nowords(checkd));

 return(err);
}



os_error * updatecheck(void)
{
 os_error * err;

 err=NULL;

 if(checkhandle)
 {
  setcext();
  refreshwindow(checkhandle);
 }

 return(err);
}




static os_error * checkclose(int w,int userhandle)
{
 os_error * err;
 int        result;

 err=NULL;

 checkmode=NOMODE;

 cprintf("check close");

 if(changes())
 {
  cprintf("changed message");

  err=confirmparent(mainhandle,CONYN,&result,"Dictionaries changed. Retain changes?");
  if(!err)
  {
   cprintf("result %d",result);

   if(result==1)
   {      /* stash stuff  */
    savechanges();
   }
   else
   {
    scrapchanges();
   }
  }
 }

 trashdc(&guessdc);
 trashdc(&scrapdc);


 if(!err)
 {
  checkcombofinit();
  
  remclickevent(checkicon,checkhandle,0);
  remkeyevent(checkkey,checkhandle,0);
  remcloseevent(checkclose,checkhandle,0);

  remclickevent(checkpaneicon,checkpanehandle,0);
  remkeyevent(checkpanekey,checkpanehandle,0);
  remredrawevent(checkpaneredraw,checkpanehandle,0);
  remeditevent(checkupdate,checkhandle,0);
  remcaretevent(checkpanecaret,checkpanehandle,0);

  err=closedown(&checkhandle);
 }

 return(err);

 USE(w);
 USE(userhandle);
}




static os_error * checkpaneselectn(int n)
{
 int oldn;
 int oldfocusn;

 if(n<nowords(checkd) && n>=0)
 {
  if(!(n==checkselec && n==checkfocusn))
  {
   oldfocusn=checkfocusn;
   oldn=checkselec;
   checkselec=checkfocusn=n;

   /* redraw selected icon   */
   if(oldn>=0) checkrefreshwords(oldn);
   if(oldfocusn>=0 && oldn<0) checkrefreshwords(oldfocusn); 
   /* redraw new icon        */
   checkrefreshwords(checkselec);
  }
 }

 return(NULL);
}





static os_error * checkpaneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 windowstr  window;
 int        y;

 err=NULL;

 if(m->bbits==0x4)
 {
  getw(handle,&window);
  y=-(m->y-window.by);  /* +ve number */

  /* map y into icon number */

  checkpaneselectn((y-WDMARGIN)/(editheight+WDMARGIN));

  writeicon(checkhandle,IDC_CHECK_TEXT,wordn(checkselec,checkd));

  setfocus(checkpanehandle);
 }

 return(err);

 USE(userhandle);
}






static void setcheckwin(char * name,dict * dp,int n)
{
 char caption[256];

 checkno=n;
 checkd=dp;

 tsprintf(sizeof(caption),caption,"{SPCH} (%s)",name);

 writetitle(checkhandle,caption);
 setcext();
 checkrefreshwords(-1);
 checkopenwordsn(0);
}




static void goguessmode(void)
{
 if(guessmode) return;
 setcheckwin("Guess",&guessdc,dcmap[curdict]);
 guessmode=1;
 checkselec=-1;
}




static void godictmode(int full)
{
 int n;

 n=dcmap[curdict];
 if(full)
 {
  setcheckwin(dtable[n].name,&dtable[n].dictp,n);
  checkselec=-1;
  guessmode=0;
  checkdemon();
 }
}



void toggleguessmode(void)
{
 if(guessmode) godictmode(1);
 else          goguessmode();
 selectst(checkhandle,IDC_CHECK_BROWSE,!guessmode);
}




static os_error * checkadddictword(int dno)
{
 os_error * err;
 char       buff[64];
 char     * p;

 err=iconaddr(checkhandle,IDC_CHECK_TEXT,&p);
 if(!err)
 {
  stripstring(buff,p);
  err=addword(buff,&dtable[dno].dictp);
  if(!err)
  {
   dtable[dno].modded|=1;
   setcheckextent();
   checkrefreshwords(-1);           
   checkdemon();
  }
 }
 return(err);
}




static os_error * checkpanecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 windowstr  window;
 int        oldfocusn;
 int        now;

 err=NULL;

 if(gain)
 {
  if(checkselec>=0) checkfocusn=checkselec;
  else
  {
   err=getw(handle,&window);
   if(!err)
   {
    checkfocusn=(-window.scy-WDMARGIN+(window.y1-window.y0)/2)/editheight;
    now=nowords(checkd);
    if(checkfocusn<0)   checkfocusn=0;
    if(checkfocusn>now) checkfocusn=now-1;
   }
  }
  checkrefreshwords(checkfocusn);
 }
 else
 {
  oldfocusn=checkfocusn;
  checkfocusn=-1;
  checkrefreshwords(oldfocusn);
 }


 return(err);

 USE(userhandle);
}







static os_error * checkkey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;

 err=NULL;

 if(*key==13)
 {
  checkcont();
  *key=-1;
 }
 else
 if(*key==ESCPRESS)
 {
  closecheck(1);
 }

 return(err);

 USE(icon);
 USE(handle);
 USE(userhandle);
}



static os_error * checkpanekey(int handle,int userhandle,int icon,int * key)
{
 int ch;
 int now;
 int n;


 ch=*key;
// cprintf("edit pane key %x",*key);

 if(ch==CUP || ch==CDOWN)
 {
  now=nowords(checkd);
  n=checkselec+((*key==CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=now) n=now-1;

  if(n!=checkselec)
  {
   checkpaneselectn(n);
   writeicon(checkhandle,IDC_CHECK_TEXT,wordn(n,checkd));
   checkpaneopenline(checkpanehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  setnexttabw(checkhandle,checkpanehandle,ch==SHFT_TAB);
  *key=-1;
 }
 else
 if(ch==ESCPRESS)
 {
  closecheck(1);
 }
 else
 if(ch==13)
 {
  checkcont();
  *key=-1;
 }

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(icon);
}




static os_error * checkicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {

                         
					  case      IDC_CHECK_ADD:
                               checkadddictword(dcmap[curdict]);
                               if(m->bbits & 0x1) checkcont();
                               break;

					  case IDC_CHECK_CONTINUE: // ignore word
						                         checkcont();
                               break;
					 
					 
					 case   IDC_CHECK_BROWSE:
        					     	           toggleguessmode();
                              break;


        case IDC_CHECK_CANCEL:
                        						closecheck(1);
                              break;


 }

 return(err);

 USE(handle);
 USE(userhandle);
}



static os_error * checkopen(int handle,int userhandle,wimp_openstr * open)
{
 os_error   * err;
 iconstr      icon;
 windowstr    window;
 wimp_openstr o;

 geti(handle,IDC_CHECK_PANE,&icon);
 getw(checkpanehandle,&window);

 o.w=checkpanehandle;
 o.box.x0=xpix2os(xos2pix(open->box.x0+icon.ix0)+2);
 o.box.y0=ypix2os(yos2pix(open->box.y1+icon.iy0)+2);   
 o.box.x1=xpix2os(xos2pix(open->box.x0+icon.ix1)-2);
 o.box.y1=ypix2os(yos2pix(open->box.y1+icon.iy1)-2);


 o.x=window.scx;       
 o.y=window.scy;
               
 o.behind=-1; //open->behind;

 err=wimp_open_wind_ex(&o);

 return(NULL);

 USE(userhandle);
}




static os_error * checkpaneredrawsub(wimp_redrawstr * redrawstr,int more)
{
 os_error  * err;
 int         ylo;
 int         yhi;
 int         n;
 int         y;
 int         now;
 int         ox;
 int         oy;
 word        words;
 int         deskfonthandle;
 int         width;


 err=font_find_description(&editfont,&deskfonthandle);
 if(!err)
 {
           err=font_setcolour(deskfonthandle,PALTRANSPARENT,PALBLACK,0);
  if(!err) err=font_align(FA_BASELINE|FA_LEFT);
  if(!err)
  {
   now=nowords(checkd);

   while(more)
   {
    if(now)
    {
     ox=redrawstr->box.x0-redrawstr->scx;
     oy=redrawstr->box.y1-redrawstr->scy;
     ylo=(redrawstr->g.y1-oy);
     yhi=(redrawstr->g.y0-oy);
     width=MAX((redrawstr->box.x1-redrawstr->box.x0),editwidth);

     if((editheight+WDMARGIN)==0) n=0;
     else                         n=(-ylo+WDMARGIN)/(editheight+WDMARGIN);

     y=-n*(editheight+WDMARGIN)+WDMARGIN+WDSHIFT;

     if(locword(n,checkd,&words))
     {
      while(y>=yhi && n<now)
      {
       if(n==checkselec)
       {
        wimp_setcolour(WIMPBLACK);
        bbc_rectanglefilli(ox+WDXMARGIN,oy+y,width,-editheight);
        font_setforeground(PALWHITE);
        font_paint(words.string,font_ABS|font_OSCOORDS|font_BACKBLEND,ox+WDXMARGIN,oy+y-editleading);
        font_setforeground(PALBLACK);
       }
	      else
       {
        font_paint(words.string,font_ABS|font_OSCOORDS|font_BACKBLEND,ox+WDXMARGIN,oy+y-editleading);
       }

       if(n==checkfocusn)
       {
        wimp_setcolour(n==checkselec?WIMPWHITE:WIMPBLACK);
        bbc_setstyle(1);
        bbc_rectanglei(ox+WDXMARGIN,oy+y,width,-editheight);
       }

       y-=editheight+WDMARGIN;
       n++;
       nextword(checkd,&words);
      }
     }
    } 
    wimp_get_rectangle(redrawstr,&more);
   }
  }
  font_lose(deskfonthandle);
 }

 return(err);
}





static os_error * checkpaneredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;

          err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=checkpaneredrawsub(&redrawstr,more);

 return(err);

 USE(userhandle);
}







void closecheck(int ok)
{ 
 checkclose(checkhandle,ok);

}



static os_error * opencheck(int parent)
{
 os_error * err;
 int        n;
 char       caption[256];

 curdict=0;

 n=dcmap[curdict];

 checkselec=checkfocusn=-1;

 if(guessmode)
 {
  checkno=n;
  checkd=&guessdc;
  checktitle="Guess";
 }
 else
 {
  checkd=&dtable[n].dictp;
  checkno=n;
  checktitle=dtable[n].name;
 }

 tsprintf(sizeof(caption),caption,"{SPCH} (%s)",checktitle);

           err=createwindowtitleparent(TCHECK,caption,&checkhandle,parent);
  if(!err) err=createwindowparent(TPANE,&checkpanehandle,checkhandle);
  if(!err)
  {
   addclickevent(checkicon,checkhandle,0);
   addkeyevent(checkkey,checkhandle,0);
   addcloseevent(checkclose,checkhandle,0);
//   addopenevent(checkopen,checkhandle,0);

   addclickevent(checkpaneicon,checkpanehandle,0);
   addkeyevent(checkpanekey,checkpanehandle,0);
   addredrawevent(checkpaneredraw,checkpanehandle,0);
   addeditevent(checkupdate,checkhandle,0);
   addcaretevent(checkpanecaret,checkpanehandle,0);

   wimp_setwindowbackground(checkpanehandle,CCRGB|PALWHITE);
//   wimp_setwindowflags(checkpanehandle,WINDOWFIXED,0);
   wimp_setwindowflags(checkpanehandle,WINDOWNOTDIALOGUE,0);

   checkcomboinit(checkhandle);

   popup(checkhandle,0);
   wimp_wstate wblock;
   wimp_get_wind_state(checkhandle,&wblock);
   checkopen(checkhandle,0,&wblock.o);


   setcheckextent();

   iecarrot(checkhandle,IDC_CHECK_TEXT);
  }


 selectst(checkhandle,IDC_CHECK_BROWSE,!guessmode);

 createdc(&scrapdc);

 return(err);
}








int spellerror(char * string)
{

 makeguess(string);

 if(checkmode==NOMODE)
 {
  opencheck(mainhandle);
 }

 writeicon(checkhandle,IDC_CHECK_TEXT,checkstring);

 if(!guessmode)  checkdemon();
 else
 if(checkmode!=NOMODE)
 {
  checkselec=checkfocusn=-1;
  iecarrot(checkhandle,IDC_CHECK_TEXT);
  setcext();
  checkopenwordsn(0);
  checkrefreshwords(-1);
 }

 checkmode=CHECKS;

 return(1);
}







static dict * editd;
static int    editno;
static int    wselec;
static int    focusn;
static int    edithandle;
static int    editpanehandle;






/*

static void openewordsn(int n)
{
 int       y;
 windowstr window;

 getw(editpanehandle,&window);

 y=-(n+1)*(WDMARGIN+editheight)+((window.y1-window.y0)/2);

 openatscroll(editpanehandle,0,y);
}

*/


static void editpaneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*editheight+WDMARGIN);
 bot=-((n+1)*editheight+WDMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

 wimp_open_wind(&wblock.o);
}






static os_error * refreshwords(int n)
{
 os_error       * err;
 wimp_redrawstr   r;
 windowstr        window;

 err=getw(editpanehandle,&window);
 r.box.x0=0;
 r.box.x1=window.x1-window.x0;

 if(n<0)
 {
  r.box.y1=window.scy;
  r.box.y0=r.box.y1-(window.y1-window.y0);
 }
 else
 {
  r.box.y1=-n*(editheight+WDMARGIN)-WDMARGIN-WDSHIFT+2*cvdu.extray;
  r.box.y0=r.box.y1-editheight-WDMARGIN-4*cvdu.extray;
 }

 r.w=editpanehandle;
 wimp_force_redraw(&r);

 return(err);
}




static void editdemon(void)
{
 os_error * err;
 int        found;
 int        n;
 int        ntemp;
 int        flags=0;
 word       words;
 char       buff[64];
 char     * p;


 err=iconaddr(edithandle,IDC_EDIT_TEXT,&p);
 if(!err)
 {
  stripstring(buff,p);

  found=findword(buff,editd,&words,&flags);
  if(flags & 0x1) found=0;
  n=words.wordn;

  if(!found || n!=wselec)
  {
   editpaneopenline(editpanehandle,n);
   if(wselec>=0)
   {
    ntemp=wselec;
    wselec=-1;
    refreshwords(ntemp);
   }

   if(found)
   {
    wselec=n;
    refreshwords(wselec);
   }
  }
 }
}


static os_error * editupdate(int handle,int icon,int userhandle)
{
 editdemon();
 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}





static os_error * setwext(void)
{
 os_error * err;
 int        miny;

 miny=nowords(editd)*(editheight+WDMARGIN)+WDMARGIN;  

 err=extent(editpanehandle,0,-miny,editwidth,0);

 return(err);
}





static os_error * seteditextent(void)
{
 os_error * err;
 
          err=setwext();
 if(!err) err=writeiconf(edithandle,IDC_EDIT_WORDS,"%d",nowords(editd));

 return(err);
}


os_error * updateedit(void)
{
 os_error * err;

 err=NULL;

 if(edithandle)
 {
  setwext();
  refreshwindow(edithandle);
 }

 return(err);
}


static os_error * editadddictword(int dno)
{
 os_error * err;
 char       buff[64];
 char     * p;

 err=iconaddr(edithandle,IDC_EDIT_TEXT,&p);
 if(!err)
 {
  stripstring(buff,p);
  err=addword(buff,&dtable[dno].dictp);
  if(!err)
  {
   dtable[dno].modded|=1;
   seteditextent();
   refreshwords(-1);           
   editdemon();
  }
 }
 return(err);
}





static os_error * editdeletedictword(int dno)
{
 os_error * err;
 int        code;
 word       words;


 err=NULL;
 
 if(wselec>=0 && wselec<nowords(editd))
 {
  code=locword(wselec,&dtable[dno].dictp,&words);
  if(code)
  {
   code=remword(&dtable[dno].dictp,&words);
   dtable[dno].modded|=code;
   seteditextent();
   refreshwords(-1);
   editdemon();
  }
 }
 return(err);
}








/* a file of words has been dropped onto the edit window */

static os_error * readdc(char * name)
{
 os_error * err;
 buffer     bf;
 int        c=0;
 char       string[STRLEN];
 int        i;


 err=bf_open(name,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
  hourglasson();

  while(1)
  {
   while(1)
   {
    err=bf_getc(&bf,&c);
    if(err || c==EOF) break;
    if(c>32) break;
   }

   if(err || c==EOF) break;

   i=0;
   string[i++]=(char)c;

   while(i<STRLEN) 
   {
    err=bf_getc(&bf,&c);
    if(err || c==EOF) break;
    if(c<32) break;
    if(isalpha((char)c)) string[i++]=(char)tolower((char)c);
   } 


   if(i<STRLEN)
   {
    string[i]=0;
    err=addword(string,editd);
    dtable[editno].modded|=1;
   }

   if(err || c==EOF) break;
  }

  err=bf_close(&bf,err);
  seteditextent();
  refreshwords(-1);

  hourglassoff();
 }

 return(err);
}



/* save dictionary as text */
                  
static os_error * writedc(char * name)
{
 os_error * err;
 buffer     bf;
 word       words;

 err=NULL;

 if(nowords(editd))
 {
  err=bf_open(name,'w',DEFBUFFSIZE,&bf);
  if(!err)
  {
   locword(0,editd,&words);
   do
   {
    bf_write(&bf,words.string,strlen(words.string));
    bf_write(&bf,"\r\n",2);
   } while(nextword(editd,&words));
   err=bf_close(&bf,err);
  }
 }
 return(err);
}



static os_error * csaveoption(int handle,int opt,int * type,char * name,int maxsize)
{

 switch(opt)
 {
  case 0:
         *type=TEXTFILE;
         break;
 }


 return(NULL);
 USE(handle);
 USE(name);
	USE(maxsize);
}




static saveoptionstr saveoptions[]=
{
 "Text file of words (*.txt)",  csaveoption,

};




static int csaveopt;




static os_error * csavefile(char * name,int type)
{
 os_error * err;

 err=NULL;

 switch(type)
 {

   case TEXTFILE:
                err=writedc(name);
                break;

 }

 return(err);
}




static os_error * saveedit(int handle)
{
 os_error * err;
 char       savepath[MAX_PATH];

 setsaveoptions(1,saveoptions,&csaveopt);
 strcpy(savepath,"TextFile");
 err=opensaveparent(savepath,NITEM(savepath),TEXTFILE,csavefile,handle);

 return(err);
}





static os_error *loadedittypev(char * name,int type,mousestr * m,int userhandle,int * method)
{
 if(type==TEXTFILE)                     *method=1;
 else                                   *method=0;

 return(NULL);
 USE(userhandle);
 USE(m);
 USE(name);
}




static os_error * loadeditv(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

 err=readdc(name);

 return(err);
 USE(userhandle);
 USE(type);
 USE(xvolatile);
}



static os_error * loadeditpostv(int userhandle)
{
 os_error    * err;

/* dprintf(0,"load doc post"); */

 err=NULL;


 return(err);

 USE(userhandle);
}



os_error * loadedit(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

          err=loadeditv(name,type,0,0);
 if(!err) err=loadeditpostv(0);

 return(err);

 USE(userhandle);
 USE(xvolatile);
}




static os_error * openedit(int handle)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=TEXTFILE;
 int        copt;
 char       name[MAX_PATH];

 opts.description="Text file of words (*.txt)";
 opts.ntypes=1;
 opts.types=&xtype;

 strcpy(name,"");

 err=openloadparent(name,&copt,&opts,1,loadedit,0,handle);

 return(err);
}








static os_error * editicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * editpaneicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * editpaneredraw(int handle,int userhandle);
static os_error * editkey(int handle,int userhandle,int icon,int * key);
static os_error * editpanekey(int handle,int userhandle,int icon,int * key);
static os_error * editpanecaret(int handle,int userhandle,int gain);


static os_error * editclose(int w,int userhandle)
{
 os_error * err;

 err=NULL;

 if(!err)
 {
  remclickevent(editicon,edithandle,0);
  remcloseevent(editclose,edithandle,0);

  remclickevent(editpaneicon,editpanehandle,0);
  remkeyevent(editpanekey,editpanehandle,0);
  remkeyevent(editkey,edithandle,0);
  remredrawevent(editpaneredraw,editpanehandle,0);
  remdataload(editpanehandle,0,loadeditv);
  remdataloadpost(editpanehandle,0,loadeditpostv);
  remdataloadtype(editpanehandle,0,loadedittypev);
  remeditevent(editupdate,edithandle,0);
  remcaretevent(editpanecaret,editpanehandle,0);

  err=closedown(&edithandle);
  if(!err)
  {
  }
 }

 return(err);

 USE(w);
 USE(userhandle);
}



os_error * editdictdecode(int * menu,int window)
{
 os_error * err;


 err=NULL;

 switch(menu[0])
 {
  case ID_DICT_IMPORTWORDS:
                           err=openedit(window);
                           break;

  case ID_DICT_EXPORTWORDS:
                           err=saveedit(window);
                           break;

 }

 return(err);
}



static os_error * editpaneselectn(int n)
{
 int oldn;
 int oldfocusn;

 if(n<nowords(editd) && n>=0)
 {
  if(!(n==wselec && n==focusn))
  {
   oldfocusn=focusn;
   oldn=wselec;
   focusn=wselec=n;

   /* redraw selected icon   */
   if(oldn>=0) refreshwords(oldn);
   if(oldfocusn>=0 && oldn<0) refreshwords(oldfocusn);
   /* redraw new icon        */
   refreshwords(wselec);
  }
 }

 return(NULL);
}





static os_error * editpaneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 windowstr  window;
 int        y;

 err=NULL;

 if(m->bbits==0x1)
 {
  linkmenu(MDICT,0,0);
  err=openupmenu(handle,MDICT);
 }
 else
 if(m->bbits==0x4)
 {
  getw(handle,&window);
  y=-(m->y-window.by);  /* +ve number */

  /* map y into icon number */

  editpaneselectn((y-WDMARGIN)/(editheight+WDMARGIN));
  writeicon(edithandle,IDC_EDIT_TEXT,wordn(wselec,editd));
  setfocus(editpanehandle);
 }

 return(err);

 USE(userhandle);
}




static os_error * editpanecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 windowstr  window;
 int        oldfocusn;
 int        now;

 err=NULL;

 if(gain)
 {
  if(wselec>=0) focusn=wselec;
  else
  {
   err=getw(handle,&window);
   if(!err)
   {
    focusn=(-window.scy-WDMARGIN+(window.y1-window.y0)/2)/editheight;
    now=nowords(editd);
    if(focusn<0)   focusn=0;
    if(focusn>now) focusn=now-1;
   }
  }
  refreshwords(focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  refreshwords(oldfocusn);
 }


 return(err);

 USE(userhandle);
}




static os_error * editkey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;

 err=NULL;


 if(*key==13)
 {                                           /* add word to dictionary */
  err=editadddictword(editno);
  *key=-1;
 }


 return(err);
 USE(icon);
 USE(userhandle);
 USE(handle);
}


// have to declare as not dbox to get cursor keys
// outside the dbhi framework key presses don't get passed to main window.


static os_error * editpanekey(int panehandle,int userhandle,int icon,int * key)
{
 int ch;
 int now;
 int n;
 int next;

 ch=*key;

 if(ch==CUP || ch==CDOWN)
 {
  now=nowords(editd);
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=now) n=now-1;

  if(n!=wselec)
  {
   editpaneselectn(n);
   writeicon(edithandle,IDC_EDIT_TEXT,wordn(n,editd));
   editpaneopenline(editpanehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(edithandle,panehandle,ch==SHFT_TAB,&next);
  setfocusicon(edithandle,next);
  *key=-1;
 }
 else
 if(ch==ESCPRESS)
 {
  scrapchanges();
  editclose(edithandle,userhandle);
  *key=-1;
 }


 return(NULL);

 USE(userhandle);
 USE(icon);
}









static os_error * editicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
        case IDC_EDIT_OK:
                         savechanges();
									                //enddemon(scrollwnd);
                         editclose(handle,userhandle);
                         break;

           case IDCANCEL:
                         scrapchanges();
									                //enddemon(scrollwnd);
                         editclose(handle,userhandle);
                         break;


					  case IDC_EDIT_ADD:
                         err=editadddictword(editno);
                         break;

		  case IDC_EDIT_DELETE:
                         err=editdeletedictword(editno);
                         break;
					 
					 
 }

 return(err);

 USE(handle);
 USE(userhandle);
}



static os_error * editopen(int handle,int userhandle,wimp_openstr * open)
{
 os_error * err;
 iconstr   icon;
 windowstr window;
 wimp_openstr o;

 geti(handle,IDC_EDIT_PANE,&icon);
 getw(editpanehandle,&window);

 o.w=editpanehandle;
 o.box.x0=xpix2os(xos2pix(open->box.x0+icon.ix0)+2);
 o.box.y0=ypix2os(yos2pix(open->box.y1+icon.iy0)+2);   
 o.box.x1=xpix2os(xos2pix(open->box.x0+icon.ix1)-2);
 o.box.y1=ypix2os(yos2pix(open->box.y1+icon.iy1)-2);


 o.x=window.scx;       
 o.y=window.scy;
               
 o.behind=-1; //open->behind;

 err=wimp_open_wind_ex(&o);

 return(err);

 USE(userhandle);
}




static os_error * editpaneredrawsub(wimp_redrawstr * redrawstr,int more)
{
 os_error  * err;
 int         ylo;
 int         yhi;
 int         n;
 int         y;
 int         now;
 int         ox;
 int         oy;
 word        words;
 int         deskfonthandle;
 int         width;


 err=NULL;

 now=nowords(editd);

 while(more)
 {
  err=font_find_description(&editfont,&deskfonthandle);
  if(!err)
  {
            err=font_setcolour(deskfonthandle,PALTRANSPARENT,PALBLACK,0);
   if(!err) err=font_align(FA_BASELINE|FA_LEFT);
   if(!err)
   {
    if(now)
    {
     ox=redrawstr->box.x0-redrawstr->scx;
     oy=redrawstr->box.y1-redrawstr->scy;
     ylo=(redrawstr->g.y1-oy);
     yhi=(redrawstr->g.y0-oy);
     width=MAX((redrawstr->box.x1-redrawstr->box.x0),editwidth);

     if((editheight+WDMARGIN)==0) n=0;
     else                       n=(-ylo+WDMARGIN)/(editheight+WDMARGIN);

     y=-n*(editheight+WDMARGIN)+WDMARGIN+WDSHIFT;

     if(locword(n,editd,&words))
     {
      while(y>=yhi && n<now)
      {
       if(n==wselec)
       {
        wimp_setcolour(WIMPBLACK);
        bbc_rectanglefilli(ox+WDXMARGIN,oy+y,width,-editheight);
        font_setforeground(PALWHITE);
        font_paint(words.string,font_ABS|font_OSCOORDS|font_BACKBLEND,ox+WDXMARGIN,oy+y-editleading);
        font_setforeground(PALBLACK);
       }
       else
       {
        font_paint(words.string,font_ABS|font_OSCOORDS|font_BACKBLEND,ox+WDXMARGIN,oy+y-editleading);
       }

       if(n==focusn)
       {
        wimp_setcolour(n==wselec?WIMPWHITE:WIMPBLACK);
        bbc_setstyle(1);
        bbc_rectanglei(ox+WDXMARGIN,oy+y,width,-editheight);
       }

       y-=editheight+WDMARGIN;
       n++;
       nextword(editd,&words);
      }
     } 
    }
   }
   font_lose(deskfonthandle);
  }
  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}





static os_error * editpaneredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;

          err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=editpaneredrawsub(&redrawstr,more);

 return(err);

 USE(userhandle);
}








os_error * openeditd(int parent,int no,dict * dp,char * title)
{
 os_error * err;
 char       caption[256];
 
 editd=dp;
 editno=no;
 wselec=focusn=-1;

 if(edithandle) err=forward(edithandle,0,NULL);
 else
 {
  tsprintf(sizeof(caption),caption,"{EDIT} (%s)",title);

           err=createwindowtitleparent(TEDIT,caption,&edithandle,parent);
  if(!err) err=createwindowparent(TPANE,&editpanehandle,edithandle);
  if(!err)
  {
   addclickevent(editicon,edithandle,0);
   addkeyevent(editkey,edithandle,0);
   addcloseevent(editclose,edithandle,0);
//   addopenevent(editopen,edithandle,0);

   addclickevent(editpaneicon,editpanehandle,0);
   addkeyevent(editpanekey,editpanehandle,0);
   addredrawevent(editpaneredraw,editpanehandle,0);
   adddataload(editpanehandle,0,loadeditv);
   adddataloadpost(editpanehandle,0,loadeditpostv);
   adddataloadtype(editpanehandle,0,loadedittypev);
   addeditevent(editupdate,edithandle,0);
   if(!err) err=addcaretevent(editpanecaret,editpanehandle,0);

   wimp_setwindowbackground(editpanehandle,CCRGB|PALWHITE);
//   wimp_setwindowflags(editpanehandle,WINDOWFIXED,0);
   wimp_setwindowflags(editpanehandle,WINDOWNOTDIALOGUE,0);

   seteditextent();

   popup(edithandle,0);
   wimp_wstate wblock;
   wimp_get_wind_state(edithandle,&wblock);
   editopen(edithandle,0,&wblock.o);

   iecarrot(edithandle,IDC_EDIT_TEXT);
  }
 }


 return(err);
}


os_error * editinit(void)
{

 return(NULL);
}


/************************************************************************************/

static createdicthandle;



static os_error * createdicticon(int handle,int userhandle,wimp_mousestr * m);

static os_error * createdictclose(int w,int ok)
{
 os_error * err;
 char       string[256];

 err=readicon(w,IDC_NEWDICT_NAME,string,sizeof(string));
 if(!err)
 {
  enablewindow(mainhandle,1,0);
  
  remclickevent(createdicticon,createdicthandle,0);
  remcloseevent(createdictclose,createdicthandle,0);

  err=closedown(&createdicthandle);
  if(!err)
  {
   if(ok) err=createdict(string);
  }
 }

 return(err);

 USE(w);
}








static os_error * createdicticon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
               case IDOK:
                         err=createdictclose(handle,1);
                         break;

           case IDCANCEL:
                         err=createdictclose(handle,0);
                         break;

 }

 return(err);

 USE(userhandle);
}




os_error * createdictwindow(int parent)
{
 os_error * err;

 if(createdicthandle) err=forward(createdicthandle,0,NULL);
 else
 {
  err=createwindowparent(TNEWDICT,&createdicthandle,parent);

  if(!err)
  {
   addclickevent(createdicticon,createdicthandle,0);
   addcloseevent(createdictclose,createdicthandle,0);

   popup(createdicthandle,0);
   iecarrot(createdicthandle,IDC_NEWDICT_NAME);

   enablewindow(mainhandle,0,0);
  }
 }

 return(err);
}


/************************************************************************************/

#define DCMENUBASE 0x100

os_error * linkmenus(void)
{
 os_error * err;
 int        i;


 err=createusermenu(MUSERF,NULL,NULL);

 if(!err)
 {
  for(i=0;i<totnames;i++)
  {
   err=addusermenu(MUSERF,dtable[i].name,0,DCMENUBASE+i);
   if(err) break;
  }
 }

 if(!err) 
 {
  completeusermenu(MUSERF,"Dictionary");
  linkmenu(MUSERF,MWORDS,LOAD_M_WORDS);
  linkmenu(MUSERF,MWORDS,EDIT_M_WORDS);
  linkmenu(MUSERF,MWORDS,DELETE_M_WORDS);
 }

 return(err);
}





void unlinkmenus(void)
{
 deleteusermenu(MUSERF);
}



void dcrebuild(void)
{
 unlinkmenus();
 linkmenus();
}





static os_error * tickdcmenu(void)
{
 int i;
 int j;
 int tick;

 for(i=0;i<totnames;i++)
 {
  tick=0;

  if(1)
  {
   for(j=0;j<nodc;j++)
   {
    if(dcmap[j]==i)
    {
     tick=1;
     break;
    }
   }
  }

  tickmenust(MUSERF,DCMENUBASE+i,tick);
 }

 return(NULL);
}




static os_error * untickdcmenu(void)
{
 int i;

 for(i=0;i<totnames;i++)
 {
  tickmenust(MUSERF,DCMENUBASE+i,0);
 }

 return(NULL);
}



os_error * dictdynamic(int * menu,char * handle,int window)
{
 os_error * err;
 
 if(menu[0]==1) err=tickdcmenu();
 else           err=untickdcmenu();

 return(err);

 USE(window);
 USE(handle);
}



os_error * dictdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;


 switch(menu[0])
 {

  case   LOAD_M_WORDS:
                      err=loaddict(menu[1]-DCMENUBASE);
	                     break;

  case   EDIT_M_WORDS:
                      err=editdict(menu[1]-DCMENUBASE);
	                     break;

  case DELETE_M_WORDS:
                      err=deletedict(menu[1]-DCMENUBASE);
                      break;

 }

 return(err);

 USE(window);
}


