// gridexport.cpp
//

#include "stdafx.h"
#include "resource.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "etc.h"


#include "os.h"
#include "wimp.h"
#include "bbc.h"
#include "akbd.h"
#include "font.h"
#include "werr.h"

#include "deb.h"

#include "wos.h"
#include "poll.h"
#include "key.h"
#include "bf.h"
#include "save.h"
#include "colour.h"
#include "osunits.h"
#include "wmf.h"

#include "constants.h"
#include "main.h"
#include "memblock.h"
#include "dc.h"
#include "sp.h"
#include "soln.h"
#include "edit.h"
#include "mainwin.h"


#include "grid.h"


#include "gridexport.h"



/**********************************************************************************/

static int mfmeshx;
static int mfmeshy;
static int cluelead;
static int textlead;
static int textheight;



static os_error * mfsetup(void)
{
 os_error    * err;
 font_metric   metric;

 mfmeshx=mfmeshy=(textfont.height*OSYRES*gridmeshratio)/(16*72*100);

 err=font_getmetric_description(&textfont,&metric);
 if(!err)
 {
  textlead=ypix2os(metric.ascent);
  textheight=ypix2os(metric.height);

  err=font_getmetric_description(&cluefont,&metric);

  cluelead=ypix2os(metric.ascent);


  cprintf("mfmeshx %d",mfmeshx);

//  cprintf("textheight %d textlead %d cluelead %d clueheight %d",textheight,textlead,cluelead,ypix2os(metric.height));
 }
 
 return(err);
}



// got a problem here, can't read font metrics for wmf's (OK for emf's though)


static os_error * drawgrid(void)
{
 os_error       * err;
 int              x;
 int              y;
 int              clue;
 char             string[8];
 int              i;
 int              fonthandle=0;
 wrdstr         * w;
 int              len;


          err=setgcol(emptycolour);
 if(!err) err=bbc_rectanglefilli(0,0,maxx*meshx,maxy*mfmeshy);


 if(!err) err=setgcol(gridcolour);

 if(!err)
 {
  for(x=0;x<=maxx;x++)
  {
   bbc_move(x*mfmeshx,0);
   bbc_draw(x*mfmeshx,maxy*mfmeshy);
  }

  for(y=0;y<=maxy;y++)
  {
   bbc_move(0,y*mfmeshy);
   bbc_draw(maxx*mfmeshx,y*mfmeshy);
  }


  if(gridtype==CROSSTYPE)
  {
   for(x=0;x<maxx;x++)
   {
    for(y=0;y<maxy;y++)
    {
     if(gridstate[x][y] & BLOCKX)
     {
 //    bbc_move(x*DX,y*DY);
 //    bbc_draw(x*DX,(y+1)*DY);
      bbc_rectanglefilli(x*mfmeshx-1,y*mfmeshy,2,mfmeshy);
     }

     if(gridstate[x][y] & BLOCKY)
     {
 //    bbc_move(x*DX,y*DY);
 //    bbc_draw((x+1)*DX,y*DY);
      bbc_rectanglefilli(x*mfmeshx,y*mfmeshy-1,mfmeshx,2);
     }
    }
   }


   setgcol(fillcolour);

   for(x=0;x<maxx;x++)
   {
    for(y=0;y<maxy;y++)
    {
     if((gridstate[x][y] & STMASK)==BLOCK)
     {
      bbc_rectanglefilli(x*mfmeshx,y*mfmeshy,mfmeshx+1,mfmeshy+1);
     }
    }
   }

   /* now do clue numbers */

   for(x=0;x<maxx;x++)
   {
    for(y=0;y<maxy;y++)
    {
     if((gridstate[x][y] & STMASK)==BLOCK)
     {
      gridstate[x][y]|=(XMASK+YMASK);
     }
     else
     {
      gridstate[x][y]&=~(XMASK+YMASK);
     }
    }
   }


   err=font_find_description(&cluefont,&fonthandle);
   if(!err)
   {
    err=font_setcolour(fonthandle,PALTRANSPARENT,textcolour,0);
    if(!err) err=font_align(FA_LEFT|FA_BASELINE);

    clue=1;

    for(y=0;y<maxy;y++)
    {
     for(x=0;x<maxx;x++)
     {
      if((gridstate[x][y] & STMASK)!=BLOCK)
      {
       if(((!(gridstate[x][y] & XMASK)) && 
           (x<(maxx-1)) && 
           (!(gridstate[x+1][y] & (XMASK|BLOCKX)))) ||
          ((!(gridstate[x][y] & YMASK)) && 
           (y<(maxy-1)) && 
           (!(gridstate[x][y+1] & (YMASK|BLOCKY))))
         )
       {
        sprintf(string,"%d",clue++);
        font_paint(string,font_ABS|font_OSCOORDS|font_BACKBLEND,x*mfmeshx+3,y*mfmeshy+cluelead+2);

        for(i=x;i<maxx;i++) 
        {
         if((gridstate[i][y] & BLOCKX) && i!=x) break;
         if((gridstate[i][y] & STMASK)==BLOCK) break;
         gridstate[i][y]|=XMASK;
        }

        for(i=y;i<maxy;i++)
        {
         if((gridstate[x][i] & BLOCKY) && i!=y) break;
         if((gridstate[x][i] & STMASK)==BLOCK) break;
         gridstate[x][i]|=YMASK;
        }

       }
      }
     }
    }

    font_lose(fonthandle);
   }
  }
  /* now do text */

  if(!err) err=font_find_description(&textfont,&fonthandle);
  if(!err)
  {
            err=font_setcolour(fonthandle,PALTRANSPARENT,textcolour,0);
   if(!err) err=font_align(FA_CENTRE|FA_BASELINE);

   for(x=0;x<maxx;x++)
   {
    for(y=0;y<maxy;y++)
    {
     if((gridstate[x][y] & STMASK)!=BLOCK && griddata[x][y]!=32)
     {
      if(saveupper) string[0]=(char)toupper(griddata[x][y]);
  	   else          string[0]=griddata[x][y];
      string[1]=0;
      font_paint(string,font_ABS|font_OSCOORDS|font_BACKBLEND,x*mfmeshx+mfmeshx/2,y*mfmeshy+textlead+(mfmeshy-textheight)/2);
     }
    }
   }

   font_lose(fonthandle);
  }

  if(gridtype==SQUARETYPE)
  {
   if(drawsolutions)
   {
    if(nsol)
    {
     for(i=0;i<nsol;i++)
     {
      w=(wrdstr*)(sbuffer+i*sizeof(wrdstr));
      len=strlen(w->text);
 
      bbc_move(w->x*mfmeshx+mfmeshx/2,(w->y)*mfmeshy+mfmeshy/2);
      bbc_draw((w->x+w->dx*(len-1))*mfmeshx+mfmeshx/2,(w->y+w->dy*(len-1))*mfmeshy+mfmeshy/2);
     }
    }
   }
  }
 }
 return(err);
}







os_error * saveaswmf(char * name)
{
 os_error * err;
 metahandle handle;

 err=mfsetup();
 if(!err)
 {
  err=openwmf(0,maxx*mfmeshx+1,maxy*mfmeshy+1,&handle);
  if(!err)
  {
   err=drawgrid();
   err=closewmf(err,handle,name);
  }
 }
 return(err);
}



os_error * saveasplaceablewmf(char * name)
{
 os_error * err;
 metahandle handle;

 err=mfsetup();
 if(!err)
 {
  err=openpmf(0,maxx*mfmeshx+1,maxy*mfmeshy+1,&handle);
  if(!err)
  {
   err=drawgrid();
   err=closepmf(err,handle,name,0,maxx*mfmeshx+1,maxy*mfmeshy+1,0,120);
  }
 }

 return(err);
}



os_error * saveasemf(char * name)
{
 os_error * err;
 metahandle handle;
 char       desc[64];

 err=mfsetup();
 if(!err)
 {
  sprintf(desc,"Calendar\0Grid\0");
  err=openemf(name,0,maxx*mfmeshx+1,maxy*mfmeshy+1,&handle,desc);
  if(!err)
  {
   err=drawgrid();
   err=closeemf(err,handle);
  }
 }

 return(err);
}




/************************************************************************************/


static os_error * savecluescross(char * filename)
{
 os_error * err;
 FILE * fp;
 int    i;
 int    x;
 int    y;
 int    clue;
 int    first;


 err=NULL;

 fp=fopen(filename,"wb");
 if(fp)
 {
  for(x=0;x<maxx;x++)
   for(y=0;y<maxy;y++)
    if((gridstate[x][y] & STMASK)==BLOCK)
    {
     gridstate[x][y]|=(XMASK+YMASK);
    }
    else
    {
     gridstate[x][y]&=~(XMASK+YMASK);
    }

  clue=0;
  first=1;

  for(y=0;y<maxy;y++)
  {
   for(x=0;x<maxx;x++)
   {
    if((gridstate[x][y] & STMASK)!=BLOCK)
    {
     if(((!(gridstate[x][y] & XMASK)) && 
         (x<(maxx-1)) && 
         (!(gridstate[x+1][y] & (XMASK|BLOCKX)))) ||

        ((!(gridstate[x][y] & YMASK)) && 
         (y<(maxy-1)) && 
         (!(gridstate[x][y+1] & (YMASK|BLOCKY))))
       )
     {
      clue++;

      for(i=x;i<maxx;i++) 
      {
       if(gridstate[i][y] & XMASK) break;
       if((gridstate[i][y] & BLOCKX) && i!=x) break;
       if((gridstate[i][y] & STMASK)==BLOCK) break;
       gridstate[i][y]|=XMASK;
      }

      if(i>(x+1))
      {
       if(first)
       {
        fprintf(fp,"Clues across.\r\n");
        first=0;
       }

       fprintf(fp,"%d. ",clue);

       for(i=x;i<maxx;i++)
       {
        if((gridstate[i][y] & BLOCKX) && i!=x) break;
        if((gridstate[i][y] & STMASK)==BLOCK) break;
        fputc(griddata[i][y],fp);
       }

       fputc('\n',fp);
      }

      for(i=y;i<maxy;i++)
      {
       if((gridstate[x][i] & BLOCKY) && i!=y) break;
       if((gridstate[x][i] & STMASK)==BLOCK) break;
       gridstate[x][i]|=YMASK;
      }
     }
    }
   }
  }

  if(!first) fputc('\n',fp);

  for(x=0;x<maxx;x++)
   for(y=0;y<maxy;y++)
    if((gridstate[x][y] & STMASK)==BLOCK)
    {
     gridstate[x][y]|=(XMASK+YMASK);
    }
    else
    {
     gridstate[x][y]&=~(XMASK+YMASK);
    }

  clue=0;
  first=1;

  for(y=0;y<maxy;y++)
  {
   for(x=0;x<maxx;x++)
   {
    if((gridstate[x][y] & STMASK)!=BLOCK)
    {
     if(((!(gridstate[x][y] & XMASK)) && 
         (x<(maxx-1)) && 
         (!(gridstate[x+1][y] & (XMASK|BLOCKX)))) ||

        ((!(gridstate[x][y] & YMASK)) && 
         (y<(maxy-1)) && 
         (!(gridstate[x][y+1] & (YMASK|BLOCKY))))
       )
     {
      clue++;

      for(i=x;i<maxx;i++) 
      {
       if((gridstate[i][y] & BLOCKX) && i!=x) break;
       if((gridstate[i][y] & STMASK)==BLOCK) break;
       gridstate[i][y]|=XMASK;
      }

      for(i=y;i<maxy;i++)
      {
       if(gridstate[x][i] & YMASK) break;
       if((gridstate[x][i] & BLOCKY) && i!=y) break;
       if((gridstate[x][i] & STMASK)==BLOCK) break;
       gridstate[x][i]|=YMASK;
      }


      if(i>(y+1))
      {
       if(first)
       {
        fprintf(fp,"Clues down.\n\n");
        first=0;
       }

       fprintf(fp,"%d. ",clue);

       for(i=y;i<maxy;i++)
       {
        if((gridstate[x][i] & BLOCKY) && i!=y) break;
        if((gridstate[x][i] & STMASK)==BLOCK) break;
        fputc(griddata[x][i],fp);
       }

       fputc('\n',fp);
      }

     }
    }
   }
  }
  fclose(fp);
 }

 return(err);
}



static os_error * savecluessquare(char * filename)
{
 os_error * err;
 FILE     * fp;
 int        i;
 wrdstr   * w;

 err=NULL;

 fp=fopen(filename,"wb");
 if(fp)
 {
  for(i=0;i<nsol;i++)
  {
   w=(wrdstr*)(sbuffer+i*sizeof(wrdstr));
   fprintf(fp,"%s\n",w->text);
  }
  fclose(fp);
 }

 return(err);
}


static os_error * saveclues(char * filename)
{
 if(gridtype==CROSSTYPE) return(savecluescross(filename));
 else                    return(savecluessquare(filename));
}



static os_error * csaveoption(int handle,int opt,int * type,char * name,int maxlen)
{
 switch(opt)
 {

  case 0:
         *type=TEXTFILE;
         break;

 }

 return(NULL);
 USE(handle);
 USE(name);
 USE(maxlen);
}




static saveoptionstr saveoptions[]=
{
 "Text file (*.txt)", csaveoption,

};




static int csaveopt;



static os_error * csavefile(char * name,int type)
{
 os_error * err;

 err=NULL;

 switch(type)
 {

   case TEXTFILE:
                 err=saveclues(name);
                 break;
 }

 return(err);
}




os_error * savecluesas(int handle)
{
 os_error * err;
 char       savepath[MAX_PATH];

 setsaveoptions(1,saveoptions,&csaveopt);
 strcpy(savepath,"Clues");
 err=opensaveparent(savepath,NITEM(savepath),TEXTFILE,csavefile,handle);

 return(err);
}


