/*->c.mainwin */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "conf.h"
#include "etc.h"
#include "flex.h"
#include "sp.h"
#include "deb.h"
#include "appinfo.h"
#include "appreg.h"
#include "mlo.h"
#include "osunits.h"
#include "oshelp.h"
#include "colour.h"
#include "xmath.h"
#include "bf.h"
#include "font.h"


#include "resource.h"


#include "constants.h"

#include "reslink.h"


#include "file.h"
#include "main.h"
#include "soln.h"
#include "grid.h"
#include "gridexport.h"
#include "memblock.h"
#include "dc.h"
#include "spell.h"
#include "edit.h"
#include "customgrid.h"
#include "cxchoices.h"

#include "mainwin.h"



int    mainhandle;
int    gridhandle;
int    solnhandle;
int    buttonshandle;

int    splitfraction=0x5000;
int    loadwidth;
int    loadheight;

char    griddata[MAXX][MAXY];
char    gridstate[MAXX][MAXY];
char    gridcnt[MAXX][MAXY];


int      nsol;                      /* number of  solutions          */
int      solwidth=1;                /* number of  words per solution */
int      solheight=32;              /* height of  solution in window - set by setupclues */
int      solxwidth;
int      solnleading;
int      solnintheight;
int      solnextheight;
int      solncharwidth;
int      solnmaxn=1000;
int      minsollen=5;
int      dmask=DEFWSQDIR;
int      drawsolutions=1;
int      editleading;
int      editheight;
int      editwidth;

int      gridtype=SQUARETYPE;


int cursorcolour=0xffbb0000;
int zonecolour=0xbbeeee00;
int textcolour=0x0;
int gridcolour=0x0;
int fillcolour=0x0;
int emptycolour=0xffffff00;
int gridmeshratio=180;


int defcursorcolour=0xffbb0000;
int defzonecolour=0xbbeeee00;
int deftextcolour=0x0;
int defgridcolour=0x0;
int deffillcolour=0x0;
int defemptycolour=0xffffff00;
int defgridmeshratio=180;


font_description textfont;

font_description deftextfont=
{
 8*16,
 0,
 "Arial",
 FD_CHARSET,
 FD_REGULAR,
 0
};


font_description cluefont;

font_description defcluefont=
{
 4*16,
 0,
 "Arial",
 FD_CHARSET,
 FD_REGULAR,
 0
};


font_description editfont;

font_description defeditfont=
{
 8*16,
 0,
 "Arial",
 FD_CHARSET,
 FD_REGULAR,
 0
};


font_description solnfont;

font_description defsolnfont=
{
 8*16,
 0,
 "Arial",
 FD_CHARSET,
 FD_REGULAR,
 0
};





int maxx=16;	// grid x cells
int maxy=16;	// grid y cells
int meshx=36;	// size of x cell
int meshy=36;	// size of y cell
int cursx=5;
int cursy=5;
int lcursx;
int lcursy;


int zx0=-1;                         /* coords of zone */
int zy0;
int zx1;
int zy1;



/************************************************************************************/


os_error * readdefaultparameters(void)
{

 textcolour=deftextcolour;
 gridcolour=defgridcolour;
 fillcolour=deffillcolour;
 emptycolour=defemptycolour;
 gridmeshratio=defgridmeshratio;

 solnfont=defsolnfont;
 editfont=defeditfont;
 cluefont=defcluefont;
 textfont=deftextfont;

 return(NULL);
}



os_error * writedefaultparameters(void)
{

 deftextcolour=textcolour;
 defgridcolour=gridcolour;
 deffillcolour=fillcolour;
 defemptycolour=emptycolour;
 defgridmeshratio=gridmeshratio;

 defcluefont=cluefont;
 deftextfont=textfont;

 return(NULL);
}








os_error * setparameters(void)
{

 meshx=meshy=(textfont.height*OSYRES*gridmeshratio)/(16*72*100);


 return(NULL);
}










static os_error * helpdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
         case ID_HELP_CHOICES:
                              err=cxchoices(window);
                              break;

  case ID_HELP_ABOUTCROSSSTAR:
                              err=infowindow(window,version,datestring);
                              break;

  case     ID_HELP_HELPTOPICS:
                              helptopic(window,"<HKEY_LOCAL_MACHINE\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\CrossStar.exe\\Path>\\CrossStar.chm>");
                              break;

  case       ID_HELP_REGISTER:
                              err=appregwindow(window);
                              break;
  
 }

 return(err);
}


static os_error * reflectdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
  case ID_REFLECT_HORIZONTAL:
                             err=reflecthoriz();
                             break;

  case   ID_REFLECT_VERTICAL:
                             err=reflectvert();
                             break;

  case  ID_REFLECT_DIAGONAL1:
                             err=reflectdiag1();
                             break;

  case  ID_REFLECT_DIAGONAL2:
                             err=reflectdiag2();
                             break;
 }

 return(err);

 USE(window);
}




static os_error * gridtypedecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {

  case  ID_GRID_GRIDTYPE_CROSSWORD:
                                   setgridtype(CROSSTYPE);
                                   break;

  case ID_GRID_GRIDTYPE_WORDSQUARE:
                                   setgridtype(SQUARETYPE);
                                   break;

 }

 return(err);

 USE(window);
}






static os_error * griddecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
  case       TYPE_M_GRID:
                         err=gridtypedecode(menu+1,window);
                         break;
 
  case    REFLECT_M_GRID:
                         err=reflectdecode(menu+1,window);
                         break;

  case ID_GRID_UPPERCASE:
                         err=setgriduppercase();
                         break;

  case ID_GRID_LOWERCASE:
                         err=setgridlowercase();
                         break;

  case    ID_GRID_CUSTOM:
                         err=customgrid(window);
                         break;

  case      ID_GRID_SIZE:
                         err=gridsize(window);
                         break;
 }

 return(err);
}




static os_error * griddynamic(int * menu,char * handle,int window)
{
 os_error * err;

 
 err=NULL;

 if(menu[0]==-1)
 {
  unshademenust(MREFLECT,ID_REFLECT_HORIZONTAL,gridtype==CROSSTYPE);
  unshademenust(MREFLECT,ID_REFLECT_VERTICAL,gridtype==CROSSTYPE);
  unshademenust(MREFLECT,ID_REFLECT_DIAGONAL1,gridtype==CROSSTYPE);
  unshademenust(MREFLECT,ID_REFLECT_DIAGONAL2,gridtype==CROSSTYPE);
  
  tickmenust(MGRID,ID_GRID_LOWERCASE,gridcase & 0x2);
  tickmenust(MGRID,ID_GRID_UPPERCASE,gridcase & 0x1);

  tickmenust(MGRID,ID_GRID_GRIDTYPE_CROSSWORD,gridtype==CROSSTYPE);
  tickmenust(MGRID,ID_GRID_GRIDTYPE_WORDSQUARE,gridtype==SQUARETYPE);
 }
 
 return(err);

 USE(window);
 USE(handle);
}





static os_error * filedynamic(int * menu,char * handle,int window)
{
 os_error * err;

 err=NULL;

 if(menu[0]==-1)
 {
  unshademenust(MFILE,ID_FILE_SAVEGRID,filecansave());
 }
 
 return(err);

 USE(window);
 USE(handle);
}






static os_error * wordsdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
  case ID_WORDS_SPELLCHECK:
                           err=spellcheck();
                           break;

 
      case ID_WORDS_CREATE:
                           err=createdictwindow(window);
                           break;

  case    LOAD_M_WORDS:
  case    EDIT_M_WORDS:
  case  DELETE_M_WORDS:
                       err=dictdecode(menu,window);
                       break;

 }

 return(err);
}


static os_error * wordsdynamic(int * menu,char * handle,int window)
{
 os_error * err;
 int        exists;
 
 err=NULL;

 
 switch(menu[0])
 {
      case              -1:
                           fs_exists(dictionarydir,&exists);
                           unshademenust(MWORDS,ID_WORDS_SPELLCHECK,gridtype==CROSSTYPE && exists);
                           unshademenust(MWORDS,ID_WORDS_CREATE,exists);



      case    LOAD_M_WORDS:
      case    EDIT_M_WORDS:
      case  DELETE_M_WORDS:
                           err=dictdynamic(menu,handle,window);
                           break;

 }

 return(err);
}








static os_error * filedecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {

  case        ID_FILE_EXIT:
                           if(termnok()==0) pollquit(0);
                           break;


  case    ID_FILE_OPENGRID:
                           err=opengrid(window);
                           break;


  case ID_FILE_SAVECLUESAS:
                           err=savecluesas(window);
                           break;


  case  ID_FILE_SAVEGRIDAS:
                           err=savegridas(window);
                           break;


  case ID_FILE_SAVEASDEFAULT:
                           err=savedefaultgrid();
                           break;

  case     ID_FILE_NEWGRID:
                           err=clear_screen();
					                      break;


  case    ID_FILE_NEWWORDS:
                           err=clear_words();
                           break;

  case    ID_FILE_SAVEGRID:
                           err=savecurrentgrid();
                           break;

 }

 return(err);
}






/* open info window and pass back pointer */

os_error * maindynamic(int * menu,char * handle,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
  case WORDS_M_MAIN:
                    err=wordsdynamic(menu+1,handle,window);
                    break;

  case  GRID_M_MAIN:
                    err=griddynamic(menu+1,handle,window);
                    break;

  case  FILE_M_MAIN:
                    err=filedynamic(menu+1,handle,window);
                    break;

 }



 USE(menu);
 USE(handle);
 USE(window);
 return(err);
}




os_error * maindecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
   case 0:
          err=filedecode(menu+1,window);
          break;

   case 1:
          err=wordsdecode(menu+1,window);
          break;

   case 2:
          err=griddecode(menu+1,window);
          break;

   case 3:
          err=helpdecode(menu+1,window);
          break;
 }
         
 return(err);
}




static os_error * mainclose(int handle,int userhandle)
{
 if(!termnok()) pollquit(0);

 return(NULL);
 USE(handle);
 USE(userhandle);
}






#define XPIXBORDER 2
#define YPIXBORDER 2

#define SPLITGAP 2



os_error * updategridtitle(void)
{
 char string[256];

 if(filecansave()) sprintf(string,"{NAME} - %s",fs_leaf(filecurrentname()));
 else              strcpy(string,"{NAME}");

 if(filemodded()) strcat(string,"*");

 writetitle(mainhandle,string);
 return(NULL);
}




static os_error * mainopen(int handle,int userhandle,wimp_openstr * open)
{
 os_error   * err;
 wimp_openstr o;
 windowstr    window;
 int          x0;
 int          x1;
 int          y0;
 int          y1;
 int          bheight;


 x0=xos2pix(open->box.x0);
 x1=xos2pix(open->box.x1);
 y1=yos2pix(open->box.y1); 
 y0=yos2pix(open->box.y0);


 geto(buttonshandle,&window);
 bheight=yos2pix(window.y1-window.y0);

 o.w=buttonshandle;
 o.box.x0=xpix2os(x0);
 o.box.y0=ypix2os(y1-bheight);   
 o.box.x1=xpix2os(x1);
 o.box.y1=ypix2os(y1);
 o.x=window.scx;       
 o.y=window.scy;
               
 o.behind=-3; //open->behind;

 err=wimp_open_wind_ex(&o);



 getw(solnhandle,&window);

 o.w=solnhandle;
 o.box.x0=xpix2os(x0);
 o.box.y0=ypix2os(y0);   
 o.box.x1=xpix2os(x0+((x1-x0)*splitfraction)/0x10000-SPLITGAP);
 o.box.y1=ypix2os(y1-bheight);
 o.x=window.scx;       
 o.y=window.scy;
               
 o.behind=-3; //open->behind;

 err=wimp_open_wind_ex(&o);

 getw(gridhandle,&window);

 o.w=gridhandle;
 o.box.x0=xpix2os(x0+((x1-x0)*splitfraction)/0x10000+SPLITGAP);
 o.box.y0=ypix2os(y0);   
 o.box.x1=xpix2os(x1);
 o.box.y1=ypix2os(y1-bheight);
 o.x=window.scx;       
 o.y=window.scy;
               
 o.behind=-3; //open->behind;

 err=wimp_open_wind_ex(&o);


 return(err);
 USE(handle);
 USE(userhandle);
}



os_error * loadopenwindow(void)
{
 os_error  * err;
 wimp_wstate wst;

 err=NULL;

 if(loadwidth && loadheight && mainhandle)
 {
  err=wimp_get_wind_state(mainhandle,&wst);

  wst.o.box.x1=wst.o.box.x0+loadwidth;
  wst.o.box.y0=wst.o.box.y1-loadheight;
 
 
  if(!err) wimp_open_wind(&wst.o);
 }
 return(err);
}




static os_error * mainsetcursor(int handle,int userhandle,wimp_mousestr * m,int * set)
{
 os_error * err;

 err=NULL;

 if(m->w==handle)
 {
  err=changepointer(ICONPOINTER,NULL,"splith");
  *set=1;
 }

 return(err);
 USE(m);
 USE(userhandle);
 USE(handle);
}



static os_error * maindrag(int handle,int userhandle,wimp_box * box)
{
 windowstr    window;
 wimp_openstr open;

 getw(handle,&window);

 splitfraction=scale(box->x0-window.x0,0x10000,window.x1-window.x0);
 if(splitfraction<(0x10000/20)) splitfraction=0x10000/20;
 if(splitfraction>(0x10000*19)/20) splitfraction=(0x10000*19)/20;

 getos(&window,&open);
 mainopen(handle,userhandle,&open);

 return(NULL);
}





static os_error * mainicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error     * err;
 wimp_dragstr   d;
 windowstr      window;

 err=NULL;

 if(m->bbits==0x40)
 {
  getw(handle,&window);
  
  d.window=handle;
  d.type=wimp_USER_SPLITTER;
  d.box.x0=m->x;
  d.box.x1=m->x;
  d.box.y0=window.y0;
  d.box.y1=window.y1;

  wimp_drag_box(&d);
  startdrag(handle,userhandle,maindrag);
 }

 return(err);
}



static int buttonscancelled;


static os_error * buttonsicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {

 case       IDC_BUTTONS_SOLVE:
                              err=solution();
                              break;

 case     IDC_BUTTONS_ANAGRAM:
                              err=anagram();
                              break;

 case        IDC_BUTTONS_STOP:
                              cprintf("stop");
                              buttonscancelled=1;
                              break;

 case  IDC_BUTTONS_DELETEWORD:
                              err=delselection();
                              break;

 case  IDC_BUTTONS_MAKESQUARE:
                              err=makegrid();
                              break;

 case   IDC_BUTTONS_NEWSQUARE:
                              err=randomgrid();
                              break;

 case IDC_BUTTONS_SOLVESQUARE:
                              err=solvesquare();
                              break;

 }


 return(err);

 USE(userhandle);
 USE(handle);
}



static os_error * buttonskey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;

 int ch=*key;

 err=NULL;

 if(icon==IDC_BUTTONS_EDIT && ch==13)
 {
  err=anagram();
  *key=-1;
 }
 else
 if(icon==IDC_BUTTONS_EDITW && ch==13)
 {
  err=addusersquaresolution();
  *key=-1;
 }

 return(err);

 USE(icon);
 USE(userhandle);
 USE(handle);
}







static os_error * buttonsinit(int mainhandle)
{
 os_error * err;
 
 err=createwindowparent(gridtype==CROSSTYPE?TBUTTONS:TBUTTONSW,&buttonshandle,mainhandle);
 if(!err)
 {
  addclickevent(buttonsicon,buttonshandle,0);
  addkeyevent(buttonskey,buttonshandle,0);
 }
 return(err);
}


os_error * buttonssolve(int solve)
{
 os_error   * err;
 wimp_openstr o;
 windowstr    window;
 int          x0;
 int          x1;
 int          y0;
 int          y1;
 int          bheight;
 windowstr    mainwindow;
 static char  savestring[STRLEN];
 int          chandle;
 static int   cicon;

 err=NULL;

 cprintf("buttons solve");


 if(mainhandle)
 {
  if(solve)
  {
   readicon(buttonshandle,IDC_BUTTONS_EDIT,savestring,sizeof(savestring));
   findcaret(&chandle,&cicon);
   if(chandle!=buttonshandle) cicon=-1;
  }

  remclickevent(buttonsicon,buttonshandle,0);
  remkeyevent(buttonskey,buttonshandle,0);
  closedown(&buttonshandle);

  buttonscancelled=0;

  if(solve)
  {
   err=createwindowparent(TBUTTONS1,&buttonshandle,mainhandle);
  }
  else
  {
   err=createwindowparent(gridtype==CROSSTYPE?TBUTTONS:TBUTTONSW,&buttonshandle,mainhandle);
   writeicon(buttonshandle,IDC_BUTTONS_EDIT,savestring);
   if(cicon!=-1) iecarrot(buttonshandle,cicon);
  }

  addclickevent(buttonsicon,buttonshandle,0);
  addkeyevent(buttonskey,buttonshandle,0);

  getw(mainhandle,&mainwindow);

  x0=xos2pix(mainwindow.x0);
  x1=xos2pix(mainwindow.x1);
  y1=yos2pix(mainwindow.y1); 
  y0=yos2pix(mainwindow.y0);

  geto(buttonshandle,&window);
  bheight=yos2pix(window.y1-window.y0);

  o.w=buttonshandle;
  o.box.x0=xpix2os(x0);
  o.box.y0=ypix2os(y1-bheight);   
  o.box.x1=xpix2os(x1);
  o.box.y1=ypix2os(y1);
  o.x=window.scx;       
  o.y=window.scy;
               
  o.behind=-3; //open->behind;

  err=wimp_open_wind_ex(&o);
 }

 return(err);
}


int buttonsevent(void)
{
 return(buttonscancelled);
}


void buttonssetevent(void)
{
 cprintf("setevent");
 buttonscancelled=1;
}


void buttonssoln(int n)
{
 static int step;
 static int nextsoln;
 
 if(n==0)
 {
  nextsoln=-1;
  step=10;
 }

 if(n>nextsoln)
 {
  writeiconf(buttonshandle,IDC_BUTTONS_SOLN,"%d",n);
  nextsoln+=step;
  if(nextsoln>100) step=100;
  else
  if(nextsoln>1000) step=1000;
 }

}


os_error * setgridtype(int gtype)
{
 os_error * err;

 err=NULL;

 if(gridtype!=gtype)
 {
  removezone();
  removecursor();
  blanksolutions();
  cleargrid();
  gridtype=gtype;
  refreshgrid();
  unmodfile();
  setgridname("");

  
  buttonssolve(0);
 }

 return(err);
}



os_error * setgridtypeload(int gtype)
{
 os_error * err;

 err=NULL;

 if(gridtype!=gtype)
 {
  gridtype=gtype;
  buttonssolve(0);
 }

 return(err);
}





os_error * openmainwindow(void)
{
 os_error    * err;
 wimp_wstate   wst;

 err=createwindow(TMAIN,&mainhandle);
 if(!err)
 {
           err=gridinit(mainhandle);
  if(!err) err=solninit(mainhandle);
  if(!err) err=buttonsinit(mainhandle);
  
  addwindowmenu(mainhandle,MMAIN);

  addcloseevent(mainclose,mainhandle,0);
  addopenevent(mainopen,mainhandle,0);

  adddataload(mainhandle,0,loadgridv);
  adddataloadpost(mainhandle,0,loadgridpostv);
  adddataloadtype(mainhandle,0,loadgridtypev);
  // grid attaches key handler to mainhandle

  addclickevent(mainicon,mainhandle,0);
  addsetcursorevent(mainsetcursor,mainhandle,0);

  popup(mainhandle,0);



  err=wimp_get_wind_state(mainhandle,&wst);
  if(!err)
  {
   if(loadwidth && loadheight)
   {
    wst.o.box.x1=wst.o.box.x0+loadwidth;
    wst.o.box.y0=wst.o.box.y1-loadheight;
   }

   centerwindow3(&wst.o,0);
   wst.o.behind=-1;
   if(!err) err=wimp_open_wind(&wst.o);
   mainopen(mainhandle,0,&wst.o);
  }

  setactive(mainhandle);
 }

 return(err);
}


